/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd.
// Author: Santhosh N

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tcl.h>
#include <pgettext.h>


int pgettext_tk(ClientData cd, Tcl_Interp *interp,
            int objc, Tcl_Obj *CONST objv[])
{
    char *msgid;
    char* retval;
    Tcl_Obj *optr;

    if(objc!=2) {
        Tcl_WrongNumArgs(interp,1,objv,"<msgid>");
        return TCL_ERROR;
    }
    if(!(msgid=Tcl_GetStringFromObj(objv[1],NULL)))
            return TCL_ERROR;

    optr = Tcl_GetObjResult(interp);

    retval = pgettext(msgid);
    Tcl_SetStringObj(optr, retval, -1);
    free(retval);

    return TCL_OK;
}

int pgettext_init_tk(ClientData cd, Tcl_Interp *interp,
            int objc, Tcl_Obj *CONST objv[])
{
    char *language_name, *domain;

    if(objc!=3) {
        Tcl_WrongNumArgs(interp,1,objv,"<language_name> <domain>");
        return TCL_ERROR;
    }

    if(!(language_name=Tcl_GetStringFromObj(objv[1],NULL)))
            return TCL_ERROR;

    if(!(domain=Tcl_GetStringFromObj(objv[2],NULL)))
            return TCL_ERROR;

    pgettext_init(language_name, domain);

    return TCL_OK;
}

int pgettext_font_tk(ClientData cd, Tcl_Interp *interp,
            int objc, Tcl_Obj *CONST objv[])
{
    char *style;
    char* size;
    Tcl_Obj *optr;
    char fontstring[512];

    if(objc!=3) {
        Tcl_WrongNumArgs(interp,1,objv,"<style = bold|medium|italics> <size = large|normal|small>");
        return TCL_ERROR;
    }

    if(!(style=Tcl_GetStringFromObj(objv[1],NULL)))
            return TCL_ERROR;

    if(!(size=Tcl_GetStringFromObj(objv[2], NULL)))
            return TCL_ERROR;

    optr = Tcl_GetObjResult(interp);
    pgettext_font(style, size, fontstring);
    Tcl_SetStringObj(optr, fontstring, -1);

    return TCL_OK;
}
